<template>
    <editor
        ref="editor"
        :initial-value="value"
        initial-edit-type="wysiwyg"
        preview-style="vertical" @change="onEditorChange"></editor>
</template>

<script>
import 'codemirror/lib/codemirror.css';
import '@toast-ui/editor/dist/toastui-editor.css';
import _ from 'lodash';

import { Editor } from '@toast-ui/vue-editor';

export default {
    name: "ToastEditor",
    props: ['value'],
    computed: {
        editorInstance() {
            return this.$refs.editor;
        },
    },
    methods: {
        onEditorChange(){
            console.log('onChange');
            this.$emit('input', this.editorInstance.invoke('getMarkdown'));
        },
        setMarkdown(val){
            console.log('setMarkdown');
            console.log(val);
            this.editorInstance.invoke('setMarkdown', val);
        }
    },
    watch: {
        value(val){
            console.log('watch');
            console.log(val);
            this.setMarkdown(val);
        }
    },
    components: {
        editor: Editor
    },
    created() {
        this.setMarkdown = _.debounce(this.setMarkdown, 1000);
    }
}
</script>

<style scoped>

</style>
